#include "smf.h"

#define RCP_CHEX 0x98

#define RCP_ROLBASE 0xdd
#define RCP_ROLPARA 0xde
#define RCP_ROLDEV 0xdf

#define RCP_BANK_PGM 0xe2
#define RCP_CH_CHANGE 0xe6
#define RCP_TEMPO 0xe7

#define RCP_CH_PRESSURE	0xea
#define RCP_CTL_CHANGE 0xeb
#define RCP_PGM_CHANGE 0xec
#define RCP_KEY_PRESSURE 0xed
#define RCP_PITCH_BEND 0xee

#define RCP_KEY_CHANGE 0xf5
#define RCP_COMMENT 0xf6
#define RCP_LOOP_END 0xf8
#define RCP_LOOP_START 0xf9
#define RCP_SAME_MEASURE 0xfc
#define RCP_MEASURE_END 0xfd
#define RCP_TRACK_END 0xfe

typedef struct {
  u_short timebase;
  u_char play_bias;
  u_char bpm;

  struct {
    u_char *memo;
    u_char *data;
  } usrex[8];

} RCPhd;

int rcp_read_header(BULK*, RCPhd*);
int rcp_read(BULK*, RCPhd*, PACKET*[]);
int rcp_read_track(BULK*, RCPhd*, PACKET*);

u_char rolex_check_sum(u_char[], int);

/*int rcp_read_event(BULK*, EVENT*, u_long*);*/
